-- logConfigCLI.lua
-- Samer Sayeed
-- TeamF1
-- www.TeamF1.com

-- Modification History
-- 19apr12,akr fixed 31231
-- 02jan12,akr fixed 28784
-- 01dec11,akr fixed 28178
-- 10feb09,ss  moved all ipv6 and firewall logs set and get routines from 
--             loggingCLI.lua.
-- 15jan09,ss  added ipv6 log routines.
log = {}

function logCfgSave(configRow)
    DBTable = "FirewallLogs"
    local configRow1 = {}
    configRow1["OtherSystemLogs.ChangeOfTimeByNTPLogs"] = configRow["FirewallLogs.ChangeOfTimeByNTPLogs"]
    configRow["FirewallLogs.ChangeOfTimeByNTPLogs"] = nil
    configRow1["OtherSystemLogs.LoginAttemptsLogs"] = configRow["FirewallLogs.LoginAttemptsLogs"]
    configRow["FirewallLogs.LoginAttemptsLogs"] = nil
    configRow1["OtherSystemLogs.SecureLoginAttempts"] = configRow["FirewallLogs.SecureLoginAttempts"]
    configRow["FirewallLogs.SecureLoginAttempts"] = nil
    configRow1["OtherSystemLogs.RebootLogs"] = configRow["FirewallLogs.RebootLogs"]
    configRow["FirewallLogs.RebootLogs"] = nil
    configRow1["OtherSystemLogs.WANStatusLogs"] = configRow["FirewallLogs.WANStatusLogs"]
    configRow["FirewallLogs.WANStatusLogs"] = nil
    configRow1["OtherSystemLogs.ResolvedDNSNames"] = configRow["FirewallLogs.ResolvedDNSNames"]
    configRow["FirewallLogs.ResolvedDNSNames"] = nil
    configRow1["OtherSystemLogs.VPNLogs"] = configRow["FirewallLogs.VPNLogs"]
    configRow["FirewallLogs.VPNLogs"] = nil
    configRow1["OtherSystemLogs.DhcpServerLogs"] = configRow["FirewallLogs.DhcpServerLogs"]
    configRow["FirewallLogs.DhcpServerLogs"] = nil
    errorFlag, statusCode = logConfigure(configRow, "1", "edit")

    --assign ipv4 FirewallLogs input to ipv6 FirewallLogs6 table 
    local firewall6Row = db.getRow("FirewallLogs6","_ROWID_", "1")
    firewall6Row["FirewallLogs6.LANToWANAccept"] = configRow["FirewallLogs.LANToWANAccept"]
    firewall6Row["FirewallLogs6.LANToWANDrop"] = configRow["FirewallLogs.LANToWANDrop"]
    firewall6Row["FirewallLogs6.WANToLANAccept"] = configRow["FirewallLogs.WANToLANAccept"]
    firewall6Row["FirewallLogs6.WANToLANDrop"] = configRow["FirewallLogs.WANToLANDrop"]
    firewall6Row["FirewallLogs6.LANToDMZAccept"] = configRow["FirewallLogs.LANToDMZAccept"]
    firewall6Row["FirewallLogs6.LANToDMZDROP"] = configRow["FirewallLogs.LANToDMZDROP"]
    firewall6Row["FirewallLogs6.DMZToWANAccept"] = configRow["FirewallLogs.DMZToWANAccept"]
    firewall6Row["FirewallLogs6.DMZToWANDrop"] = configRow["FirewallLogs.DMZToWANDrop"]
    firewall6Row["FirewallLogs6.DMZToLANAccept"] = configRow["FirewallLogs.DMZToLANAccept"]
    firewall6Row["FirewallLogs6.DMZToLANDrop"] = configRow["FirewallLogs.DMZToLANDrop"]
    firewall6Row["FirewallLogs6.WANToDMZDrop"] = configRow["FirewallLogs.WANToDMZDrop"]
    firewall6Row["FirewallLogs6.WANToDMZAccept"] = configRow["FirewallLogs.WANToDMZAccept"]
    DBTable = "FirewallLogs6"
    errorFlag, statusCode = logConfigure(firewall6Row, "1", "edit")

    -- save db if no error
    if (errorFlag == "OK") then
        DBTable = "OtherSystemLogs"
        errorFlag, statusCode = logConfigure(configRow1, "1", "edit")
        if (errorFlag == "OK") then db.save() end
    end
        local logConfig = {}
        if(configRow["logConfig.wirelessLogs"] == "1") then
            logConfig["logConfig.emergency"] = 5
            logConfig["logConfig.alert"] = 5
            logConfig["logConfig.critical"] = 5
            logConfig["logConfig.error"] = 5
            logConfig["logConfig.warning"] = 5
            logConfig["logConfig.notice"] = 5
            logConfig["logConfig.information"] = 5
            logConfig["logConfig.debug"] = 5
        else
            logConfig["logConfig.emergency"] = 0
            logConfig["logConfig.alert"] = 0
            logConfig["logConfig.critical"] = 0
            logConfig["logConfig.error"] = 0
            logConfig["logConfig.warning"] = 0
            logConfig["logConfig.notice"] = 0
            logConfig["logConfig.information"] = 0
            logConfig["logConfig.debug"] = 0
        end
        local rowId = db.existsRow("logConfig","facility","Local0-wireless")
        if (rowId) then
            valid = db.update ("logConfig",logConfig, rowId)
        else
            logConfig["logConfig.facility"] = "Local0-wireless"
            logConfig["logConfig.facilityId"] = 16
            valid = db.insert("logConfig", logConfig)
        end
    statusMessage = db.getAttribute("stringsMap","stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end

function logCfgInit(args)
    local configRow = {}
    local firewallGet = db.getRow("FirewallLogs","_ROWID_", "1")
    configRow = util.tableAppend (configRow, firewallGet)
    local otherSysGet = db.getRow("OtherSystemLogs","_ROWID_", "1")
    local logConfig = db.getRowWhere ("logConfig","facility='Local0-wireless'")
	local logConfigInfo = {}
    if ((logConfig["logConfig.emergency"] == "5") and
        (logConfig["logConfig.alert"] == "5") and
        (logConfig["logConfig.critical"] == "5") and
        (logConfig["logConfig.error"] == "5") and
        (logConfig["logConfig.warning"  ] == "5") and
        (logConfig["logConfig.notice"] == "5") and
        (logConfig["logConfig.information"] == "5") and
        (logConfig["logConfig.debug"] == "5") 
        )then
        logConfigInfo ["logConfig.wirelessLogs"] = "1"
    else
        logConfigInfo ["logConfig.wirelessLogs"] = "0"
    end
    configRow = util.tableAppend (configRow, otherSysGet)
    configRow = util.tableAppend (configRow, logConfigInfo)
   
    if (configRow == nil) then
        configRow = {}
    end
    return 1, configRow
end

function logCfgVal(configRow)
    return true
end
--[[ ipv6 logging facility
function ipv6LogsCfgSave(configRow)
    DBTable = "FirewallLogs6"
    local configRow1 = {}
    configRow1["OtherSystemLogs.ChangeOfTimeByNTPLogs"] = configRow["FirewallLogs.ChangeOfTimeByNTPLogs"]
    configRow["FirewallLogs.ChangeOfTimeByNTPLogs"] = nil
    configRow1["OtherSystemLogs.LoginAttemptsLogs"] = configRow["FirewallLogs.LoginAttemptsLogs"]
    configRow["FirewallLogs.LoginAttemptsLogs"] = nil
    configRow1["OtherSystemLogs.SecureLoginAttempts"] = configRow["FirewallLogs.SecureLoginAttempts"]
    configRow["FirewallLogs.SecureLoginAttempts"] = nil
    configRow1["OtherSystemLogs.RebootLogs"] = configRow["FirewallLogs.RebootLogs"]
    configRow["FirewallLogs.RebootLogs"] = nil
    configRow1["OtherSystemLogs.WANStatusLogs"] = configRow["FirewallLogs.WANStatusLogs"]
    configRow["FirewallLogs.WANStatusLogs"] = nil
    configRow1["OtherSystemLogs.ResolvedDNSNames"] = configRow["FirewallLogs.ResolvedDNSNames"]
    configRow["FirewallLogs.ResolvedDNSNames"] = nil
    configRow1["OtherSystemLogs.VPNLogs"] = configRow["FirewallLogs.VPNLogs"]
    configRow["FirewallLogs.VPNLogs"] = nil
    configRow1["OtherSystemLogs.DhcpServerLogs"] = configRow["FirewallLogs.DhcpServerLogs"]
    configRow["FirewallLogs.DhcpServerLogs"] = nil
    errorFlag, statusCode = logConfigure(configRow, "1", "edit")
    -- save db if no error
    if (errorFlag == "OK") then
        DBTable = "OtherSystemLogs"
        errorFlag, statusCode = logConfigure(configRow1, "1", "edit")
        if (errorFlag == "OK") then db.save() end
    end
    statusMessage = db.getAttribute("stringsMap","stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end

function ipv6LogsCfgInit(args)
    local configRow = {}
    local firewallGet = db.getRow("FirewallLogs6","_ROWID_", "1")
    configRow = util.tableAppend (configRow, firewallGet)
    local otherSysGet = db.getRow("OtherSystemLogs","_ROWID_", "1")
    configRow = util.tableAppend (configRow, otherSysGet)
   
    if (configRow == nil) then
        configRow = {}
    end
    return 1, configRow
end

function ipv6LogsCfgInputVal(configRow)
	if(configRow["FirewallLogs6.WANToLANAccept"] == nil or configRow["FirewallLogs6.WANToLANAccept"] == "" ) then
		printCLIError("Please Enter wan_to_lan_accept_enable !!")
		return false
	end
	if(configRow["FirewallLogs6.WANToLANDrop"] == nil or configRow["FirewallLogs6.WANToLANDrop"] == "" ) then
		printCLIError("Please Enter wan_to_lan_drop_enable!!")
		return false
	end
	if(configRow["FirewallLogs6.LANToWANAccept"] == nil or configRow["FirewallLogs6.LANToWANAccept"] == "" ) then
		printCLIError("Please Enter lan_to_wan_accept_enable !!")
		return false
	end
	if(configRow["FirewallLogs6.LANToWANDrop"] == nil or configRow["FirewallLogs6.LANToWANDrop"] == "" ) then
		printCLIError("Please Enter lan_to_wan_drop_enable !!")
		return false
	end
	return true
end
--
--ipv6 logging facility end
--]]
function sysEventLogsGet(args)
    printLabel("Logging Config")
    printLabel("Routing Logs")
    local firewallLogsRow = db.getRow("FirewallLogs", "_ROWID_", "1")
    local otherSysGet = db.getRow("OtherSystemLogs","_ROWID_", "1")
    local logConfig = db.getRowWhere ("logConfig","facility='Local0-wireless'")
	local logConfigInfo = {}
    if ((logConfig["logConfig.emergency"] == "5") and
        (logConfig["logConfig.alert"] == "5") and
        (logConfig["logConfig.critical"] == "5") and
        (logConfig["logConfig.error"] == "5") and
        (logConfig["logConfig.warning"  ] == "5") and
        (logConfig["logConfig.notice"] == "5") and
        (logConfig["logConfig.information"] == "5") and
        (logConfig["logConfig.debug"] == "5") 
        )then
        logConfigInfo ["logConfig.wirelessLogs"] = "1"
    else
        logConfigInfo ["logConfig.wirelessLogs"] = "0"
    end

    printLabel("LAN to WAN")
    if(firewallLogsRow["FirewallLogs.LANToWANAccept"] == "1")then 		 
        print("Accepted Packets:"," Enabled") 		 
    else
        print("Accepted Packets:"," Disabled") 		 
    end
    if(firewallLogsRow["FirewallLogs.LANToWANDrop"] == "1")then 		 
        print("Dropped Packets:"," Enabled") 		 
    else
        print("Dropped Packets:"," Disabled") 		 
    end
    printLabel("WAN to LAN") 	  	 
    if(firewallLogsRow["FirewallLogs.WANToLANAccept"] == "1")then 		 
        print("Accepted Packets:"," Enabled") 		 
    else
        print("Accepted Packets:"," Disabled") 		 
    end
    if(firewallLogsRow["FirewallLogs.WANToLANDrop"] == "1")then 		 
        print("Dropped Packets:"," Enabled") 		 
    else
        print("Dropped Packets:"," Disabled") 		 
    end
    printLabel("DMZ to WAN")
    if(firewallLogsRow["FirewallLogs.DMZToWANAccept"] == "1")then 		 
        print("Accepted Packets:"," Enabled") 		 
    else
        print("Accepted Packets:"," Disabled") 		 
    end
    if(firewallLogsRow["FirewallLogs.DMZToWANDrop"] == "1")then 		 
        print("Dropped Packets:"," Enabled") 		 
    else
        print("Dropped Packets:"," Disabled") 		 
    end

    printLabel("WAN to DMZ")
    if(firewallLogsRow["FirewallLogs.WANToDMZAccept"] == "1")then 		 
        print("Accepted Packets:"," Enabled") 		 
    else
        print("Accepted Packets:"," Disabled") 		 
    end
    if(firewallLogsRow["FirewallLogs.WANToDMZDrop"] == "1")then 		 
        print("Dropped Packets:"," Enabled") 		 
    else
        print("Dropped Packets:"," Disabled") 		 
    end
    printLabel("LAN to DMZ")
    if(firewallLogsRow["FirewallLogs.LANToDMZAccept"] == "1")then 		 
        print("Accepted Packets:"," Enabled") 		 
    else
        print("Accepted Packets:"," Disabled") 		 
    end
    if(firewallLogsRow["FirewallLogs.LANToDMZDROP"] == "1")then 		 
        print("Dropped Packets:"," Enabled") 		 
    else
        print("Dropped Packets:"," Disabled") 		 
    end
    printLabel("DMZ to LAN")
    if(firewallLogsRow["FirewallLogs.DMZToLANAccept"] == "1")then 		 
        print("Accepted Packets:"," Enabled") 		 
    else
        print("Accepted Packets:"," Disabled") 		 
    end
    if(firewallLogsRow["FirewallLogs.DMZToLANDrop"] == "1")then 		 
        print("Dropped Packets:"," Enabled") 		 
    else
        print("Dropped Packets:"," Disabled") 		 
    end
    printLabel("System Logs")
    local OtherSystemLogsRow = db.getRow("OtherSystemLogs","_ROWID_","1")
    if ( OtherSystemLogsRow ~= nil )then
		if(OtherSystemLogsRow["OtherSystemLogs.ChangeOfTimeByNTPLogs"] == "1")then
				print("Change of time by NTP: \t \t","Enabled")
		elseif(OtherSystemLogsRow["OtherSystemLogs.ChangeOfTimeByNTPLogs"] == "0")then
				print("Change of time by NTP: \t \t","Disabled")
		end
		if(OtherSystemLogsRow["OtherSystemLogs.LoginAttemptsLogs"] == "1")then
				print("Login attempts: \t \t","Enabled")
		elseif(OtherSystemLogsRow["OtherSystemLogs.LoginAttemptsLogs"] == "0")then
				print("Login attempts: \t \t","Disabled")
		end
		if(OtherSystemLogsRow["OtherSystemLogs.SecureLoginAttempts"] == "1")then
				print("Secure Login attempts: \t \t","Enabled")
		elseif(OtherSystemLogsRow["OtherSystemLogs.SecureLoginAttempts"] == "0")then
				print("Secure Login attempts: \t \t","Disabled")
		end
		if(OtherSystemLogsRow["OtherSystemLogs.RebootLogs"] == "1")then
				print("Reboots: \t \t \t","Enabled")
		elseif(OtherSystemLogsRow["OtherSystemLogs.RebootLogs"] == "0")then
				print("Reboots: \t \t \t","Disabled")
		end
		if(firewallLogsRow["FirewallLogs.UnicastTraffic"] == "1")then 		 
				print("All Unicast Traffic: \t \t","Enabled") 		 
		else
				print("All Unicast Traffic: \t \t","Disabled") 		 
		end
		if(firewallLogsRow["FirewallLogs.BroadCastORMulticastTraffic"] == "1")then 		 
				print("All Broadcast/Multicast Traffic:","Enabled") 		 
		else
				print("All Broadcast/Multicast Traffic:","Disabled") 		 
		end
		if(OtherSystemLogsRow["OtherSystemLogs.WANStatusLogs"] == "1")then
				print("WAN Status: \t \t \t","Enabled")
		elseif(OtherSystemLogsRow["OtherSystemLogs.WANStatusLogs"] == "0")then
				print("WAN Status: \t \t \t","Disabled")
		end
		if(OtherSystemLogsRow["OtherSystemLogs.ResolvedDNSNames"] == "1")then
				print("Resolved DNS Names: \t \t","Enabled")
		elseif(OtherSystemLogsRow["OtherSystemLogs.ResolvedDNSNames"] == "0")then
				print("Resolved DNS Names: \t \t","Disabled")
		end
		if(OtherSystemLogsRow["OtherSystemLogs.VPNLogs"] == "1")then
				print("VPN Logs: \t \t \t","Enabled")
		elseif(OtherSystemLogsRow["OtherSystemLogs.VPNLogs"] == "0")then
				print("VPN Logs: \t \t \t","Disabled")
		end
		if(OtherSystemLogsRow["OtherSystemLogs.DhcpServerLogs"] == "1")then
				print("DHCP Server: \t \t \t","Enabled")
		elseif(OtherSystemLogsRow["OtherSystemLogs.DhcpServerLogs"] == "0")then
				print("DHCP Server: \t \t \t","Disabled")
		end
		if(logConfigInfo["logConfig.wirelessLogs"] == "1")then
				--print("Wireless Logs: \t \t \t","Enabled")
		elseif(logConfigInfo["logConfig.wirelessLogs"] == "0")then
				--print("Wireless Logs: \t \t \t","Disabled")
		end
    end
    printLabel("Other Event Logs")
    if(firewallLogsRow["FirewallLogs.SourceMACFilter"] == "1")then 		 
        print("Source MAC Filter:"," Enabled") 		 
    else
        print("Source MAC Filter:"," Disabled") 		 
    end
    if(firewallLogsRow["FirewallLogs.SessionLimitLogs"] == "1")then 		 
        print("Session Limit: ",""," Enabled") 	
    else
        print("Session Limit: ",""," Disabled") 	
    end
    if(firewallLogsRow["FirewallLogs.BandwidthLimitLogs"] == "1")then 		 
        print("Bandwidth Limit:"," Enabled") 	
    else
        print("Bandwidth Limit:"," Disabled") 	
    end
end
--[[
function ipv6LogsCfgSave (configRow)
    DBTable = "FirewallLogs6"
    errorFlag, statusCode = logConfigure(configRow, "1", "edit")

    -- save db if no error
    if (errorFlag == "OK") then db.save() end
    statusMessage = db.getAttribute("stringsMap","stringId", statusCode, LANGUAGE)
    return errorFlag, statusMessage
end

function ipv6LogsCfgInit (args)
    configRow = db.getRow ("FirewallLogs6", "_ROWID_", "1")
    if (configRow == nil) then
        configRow = db.getDefaults(true, "FirewallLogs6")
    end    
    return 1, configRow
end

function ipv6LogsCfgInputVal (args)
    local ipMode = 
    db.getAttribute ("networkInfo", "_ROWID_", "1", "netWorkMode") or ''
    if (ipMode == "1") then
        printCLIError ("Please Set IP Mode to IPv4/IPv6 to configure IPv6 " .. 
        "Logging.\n")
        return false
    end
    return true
end

function ipv6LogsCfgGet(args)
	local FirewallLogs6Row = db.getRow("FirewallLogs6", "_ROWID_", "1")
	if( FirewallLogs6Row ~= nil) then
		printLabel("IPv6 Logging Configuration")
		printLabel("LAN-WAN Configuration")
		if(FirewallLogs6Row["FirewallLogs6.LANToWANAccept"] == "1" ) then
        		print("LAN To WAN Accept Packets:", "Enabled") 		 
		elseif(FirewallLogs6Row["FirewallLogs6.WANToLANAccept"] == "0" ) then
        		print("LAN To WAN Accept Packets:", "Disabled") 		 
		end
		if(FirewallLogs6Row["FirewallLogs6.LANToWANDrop"] == "1" ) then
        		print("LAN To WAN Drop Packets:", "Enabled") 		 
		elseif(FirewallLogs6Row["FirewallLogs6.WANToLANDrop"] == "0" ) then
        		print("LAN To WAN Drop Packets:", "Disabled") 		 
		end
		printLabel("WAN-LAN Configuration")
		if(FirewallLogs6Row["FirewallLogs6.WANToLANAccept"] == "1" ) then
        		print("WAN To LAN Accept Packets:", "Enabled") 		 
		elseif(FirewallLogs6Row["FirewallLogs6.WANToLANAccept"] == "0" ) then
        		print("WAN To LAN Accept Packets:", "Disabled") 		 
		end
		if(FirewallLogs6Row["FirewallLogs6.WANToLANDrop"] == "1" ) then
	       		print("WAN To LAN Drop Packets:", "Enabled") 		 
		elseif(FirewallLogs6Row["FirewallLogs6.WANToLANDrop"] == "0" ) then
        		print("WAN To LAN Drop Packets:", "Disabled") 		 
		end
	end
end
]]
-- log config
function log.config (inputTable, rowid, operation)
    -- validate
    if (db.typeAndRangeValidate(inputTable)) then
        if (operation == "add") then
            return false
        elseif (operation == "edit") then
            return db.update(DBTable,inputTable,rowid)
        elseif (operation == "delete") then
            return false
        end
    else
        return false
    end
end

function logConfigure (inputTable, rowid, operation)
    -- if not allowed to edit
    if (ACCESS_LEVEL ~= 0) then
    	return "ACCESS_DENIED", "ADMIN_REQD"
    end

    db.beginTransaction() --begin transaction
	local valid = false

    valid = log.config(inputTable, rowid, operation)

    -- return
    if (valid) then
        db.commitTransaction()
        return "OK", "STATUS_OK"
    else
        db.rollback()
        return "ERROR", "LOGGING_CONFIG_FAILED"
    end
end

