/* modeConfig.js - API library for mode configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01b,23rdMAR11,mvb  modified added new ipPoolvalidationCheck() for pool ip's same subnet or not.
01a,7OCT10,mvb  written.
*/


/* add_mode_config.htm  */
function autoPolicyPfsKey ()
    {
    depFieldCheck ('pfsKey', true, '', '', 'pfsKeyGroup', '');
    depFieldCheck ('pfsKey', false, 'pfsKeyGroup', '', '', '');
    }
function modeCfgDataValidate ()
    {
     /* L10N Error Message Collection Start */
     var errMsgL10n1 ='Please enter a name for the mode config data.';
     var errMsgL10n2 ='Invalid IP address for first pool start address.';
     var errMsgL10n3 ='for octet';
     var errMsgL10n4 ='Invalid IP address for first pool end address.';
     var errMsgL10n5 ='Invalid IP address for second pool start address.';
     var errMsgL10n6 ='Invalid IP address for second pool end address.';
     var errMsgL10n7 ='Invalid IP address for third pool start address.';
     var errMsgL10n8 ='Invalid IP address for third pool end address.';
     var errMsgL10n9 ='Invalid IP address for primary WINS address.';
     var errMsgL10n10 ='Invalid IP address for secondary WINS address.';
     var errMsgL10n11 ='Invalid IP address for primary DNS address.';
     var errMsgL10n12 ='Invalid IP address for secondary DNS address.';
     var errMsgL10n13 ='seconds';
     var errMsgL10n14 ='kilo bytes';
     var errMsgL10n15 ='Please enter a valid SA lifetime in';
     var errMsgL10n16 ='Invalid IP address for local IP address.';
     var errMsgL10n17 ='Invalid local subnet mask.';
     var errMsgL10n18 ='Mode config record name should not exceed 19 characters long.'
     
      /* L10N Error Message Collection End */
    
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtModeCfgRecName," + errMsgL10n1;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;

    var txtNameObj = document.getElementById ('txtModeCfgRecName');
    if (txtNameObj && !txtNameObj.disabled && txtNameObj.value.length > 19)
        {
        alert (errMsgL10n18);
        txtNameObj.focus();
        return false;
        }
    
    /* validate all IP addresses: check for empty and invalid values */
    if (ipv4AddrOctetsValidate ('tblPool1StartAddr', 'IP', false, true,
             errMsgL10n2, errMsgL10n3+" ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblPool1EndAddr', 'IP', false, true,
             errMsgL10n4, errMsgL10n3+" ", true) == false)
        return false;
        
    if(ipPoolvalidationCheck() == false)
       return false;

   
    if(getIPInt('tblPool2StartAddr')!=0)
        {       
        if (ipv4AddrOctetsValidate ('tblPool2StartAddr', 'IP', true, true,
             errMsgL10n5, errMsgL10n3+" ", true) == false)
        return false;
        }
    if(getIPInt('tblPool2EndAddr')!=0)
        {
            if (ipv4AddrOctetsValidate ('tblPool2EndAddr', 'IP', true, true,
             errMsgL10n6, errMsgL10n3+" ", true) == false)
             return false;
        }
    
    if(getIPInt('tblPool3StartAddr')!=0)
        {
        if (ipv4AddrOctetsValidate ('tblPool3StartAddr', 'IP', true, true,
             errMsgL10n7, errMsgL10n3+" ", true) == false)
             return false;
        }
    if(getIPInt('tblPool3EndAddr')!=0)
        {
        if (ipv4AddrOctetsValidate ('tblPool3EndAddr', 'IP', true, true,
            errMsgL10n8, errMsgL10n3+" ", true) == false)
            return false;
        }
            
    if(getIPInt('tblWinsPrimaryAddr')!=0)
        {     
        if (ipv4AddrOctetsValidate ('tblWinsPrimaryAddr', 'IP', true, true,
             errMsgL10n9, errMsgL10n3+" ", true) == false)
                return false;
        }
    if(getIPInt('tblWinsSecondaryAddr')!=0)
        { 
          if (ipv4AddrOctetsValidate ('tblWinsSecondaryAddr', 'IP', true, true,
            errMsgL10n10, errMsgL10n3+" ", true) == false)
                return false;
        }
    if(getIPInt('tblDnsPrimaryAddr')!=0)
        { 
        if (ipv4AddrOctetsValidate ('tblDnsPrimaryAddr', 'IP', true, true,
            errMsgL10n11, errMsgL10n3+" ", true) == false)
              return false;
        }
      
    if(getIPInt('tblDnsPrimaryAddr')!=0)
        { 
        if (ipv4AddrOctetsValidate ('tblDnsSecondaryAddr', 'IP', true, true,
             errMsgL10n12, errMsgL10n3+" ", true) == false)
              return false;
        }
    
    var saLifeTimeSecObj = document.getElementById('txtSaLifetimeInSecs');
    if (saLifeTimeSecObj || !saLifeTimeSecObj.disabled)
        {
        var suffix = errMsgL10n13;
        var type = comboSelectedValueGet ('selSaLifetimeType');
        if (type != null)
            {
            switch (parseInt (type, 10))
                {
                case 1:
                    suffix = errMsgL10n14;
                    break;
                default:
                    break;
                }
            }
        if (numericValueRangeCheck (saLifeTimeSecObj, 1, 
                               errMsgL10n15+" " + suffix,
                                '', '', false, "", "") == false)
            return false;
        }
        if(getIPInt('tblLocalIp')!=0)
        {
        if (ipv4AddrOctetsValidate ('tblLocalIp', 'SN', true, true,
             errMsgL10n16, errMsgL10n3+" ", true) == false)
                return false;
        }        
        if(getIPInt('tblLocalSubnetMask')!=0)
        {        
        if (ipv4AddrOctetsValidate ('tblLocalSubnetMask', 'SM', true, true,
            errMsgL10n17, errMsgL10n3+" ", true) == false)
                return false;
        }        

    if(saValueRangeCheck () == false)
        return false;
    if(getIPInt('tblLocalIp')!=0 || getIPInt('tblLocalSubnetMask')!=0)
        {
        if(subnetValidate('tblLocalIp', 'tblLocalSubnetMask',' for Local Subnet IP Address',true)==false){
                return false;
                }
        }            
    }
function saValueRangeCheck ()
    {

     /* L10N Error Message Collection Start */
    var errMsgL10n1 ='Invalid SA Life time value';
    var errMsgL10n2 ='seconds';
    var errMsgL10n3 ='Kbytes';
    
    var saObj = document.getElementById ('txtSaLifetimeInSecs');
    var selValue = comboSelectedValueGet ('selSaLifetimeType');
    if (selValue == null) return;
    switch (parseInt (selValue, 10))
           {
        case 0:
            return numericValueRangeCheck1 (saObj, '', '', 300, true, errMsgL10n1+":", errMsgL10n2);
               break;
        case 1:
            return numericValueRangeCheck1 (saObj, '', '', 1920000, true,errMsgL10n1+":", errMsgL10n3);
               break;
           default:
               break;
           }
    }
        

function ipPoolvalidationCheck()
    {
    var count = document.getElementById ('hdCount').value;
    for(i=1;i<=3;i++)
        {
        var stIpAddr = getIPInt("tblPool" +i+"StartAddr");
        var endIpAddr = getIPInt("tblPool"+i+"EndAddr");
        var snetMask = getIPInt1("hdSnetMask");
        if(((getIPStr("tblPool"+i+"StartAddr") != '0.0.0.0') && (getIPStr("tblPool"+i+"EndAddr") != '0.0.0.0')) && ((getIPInt("tblPool"+i+"StartAddr") != '') && (getIPInt("tblPool"+i+"EndAddr") != '')))
            {
	        if (!isInSubnet(endIpAddr, stIpAddr, snetMask))
	            {
	            if(i == 1){
	                var errorstr = "Starting and Ending IP Address must be in same subnet. for First Pool";}
	            else if(i == 2)
	                {errorstr = "Starting and Ending IP Address must be in same subnet. for Second Pool";}
	            else
	                {errorstr = "Starting and Ending IP Address must be in same subnet. for Third Pool";}
	            if (document.getElementById('txtStartIpErr'))
	                document.getElementById('txtStartIpErr').innerHTML = errorstr
	            else
	                alert (errorstr)
	            return false;
	            }
	            
	        if (endIpAddr - stIpAddr < 0)
	            {
	            if(i == 1){
	            var errorstr = "Ending IP Address should be higher than Starting IP Address. for First Pool";}
	            else if(i == 2)
	                {errorstr = "Ending IP Address should be higher than Starting IP Address. for Second Pool";}
	            else
	                {errorstr = "Ending IP Address should be higher than Starting IP Address. for Third Pool";}
	            if (document.getElementById('txtEndIpErr'))
	                document.getElementById('txtEndIpErr').innerHTML = errorstr
	            else
	                alert (errorstr)
	            return false;
	            }
	        else if(endIpAddr - stIpAddr == 0)
	            {
	            if(i == 1){
	            var errorstr = "Ending IP Address should not be equal to Starting IP Address.for First Pool";}
	            else if(i ==2){
	                errorstr = "Ending IP Address should not be equal to Starting IP Address. for Second Pool";}
	            else {
	                errorstr = "Ending IP Address should not be equal to Starting IP Address. for Third Pool";}
	            if (document.getElementById('txtEndIpErr'))
	                document.getElementById('txtEndIpErr').innerHTML = errorstr
	            else
	                alert (errorstr);
	            return false;
	            }
	         for(j=1;j<=i;j++)
	             {
	             var stIpPoolAddr = getIPInt("tblPool" +j+"StartAddr");
	             var endIpPoolAddr = getIPInt("tblPool"+j+"EndAddr");
	             if(i == j)
	             break;
	             if(i != j)
	                 {
	                 if (isInSubnet(stIpAddr, stIpPoolAddr, snetMask) && isInSubnet(endIpAddr, endIpPoolAddr, snetMask))
	                     {
	                     var errorstr = "Invalid Pool Configuration, Subnet repeated for different Pool's.";
	                     if (document.getElementById('txtStartIpErr'))
	                         document.getElementById('txtStartIpErr').innerHTML = errorstr
	                     else
	                         alert (errorstr)
	                     return false;
	                     }
	                 }
	             }
	         }
	         if((getIPStr("tblPool" +i+"StartAddr") != '0.0.0.0' && getIPInt("tblPool" +i+"StartAddr") != '') && (getIPStr("tblPool"+i+"EndAddr") != '0.0.0.0' && getIPInt("tblPool"+i+"EndAddr") != ''))
	         {
	         var rowid = document.getElementById('rowId').value;
	         for(var m=1;m<=count;m++)
	             {
	             var fstHdPoolIp = getIPInt1("firstPoolIpStart"+m);
	             var fendHdPoolIp = getIPInt1("firstPoolIpEnd"+m);
	             var sec1stHdPoolIp = getIPInt1("secondPoolIpStart"+m);
	             var secEndHdPoolIp = getIPInt1("secondPoolIpEnd"+m);
	             var third1stHdPoolIp = getIPInt1("thirdPoolIpStart"+m);
	             var thirdEndHdPoolIp = getIPInt1("thirdPoolIpEnd"+m);
	             if(rowid == m) continue;
	             if(rowid != m)
	                 {
	                 if(((document.getElementById("firstPoolIpStart"+m) != '0.0.0.0' && document.getElementById("firstPoolIpStart"+m) != '') && (document.getElementById("firstPoolIpEnd"+m) != '0.0.0.0' && document.getElementById("firstPoolIpEnd"+m) != '')) && (isInSubnet(stIpAddr, fstHdPoolIp, snetMask) || isInSubnet(endIpAddr, fendHdPoolIp, snetMask)))
	                     {
	                     alert("Invalid Pool Configuration, Subnet already used for different Record's.");
	                     return false;
	                     }
	                 else if(((document.getElementById("secondPoolIpStart"+m) != '0.0.0.0' && document.getElementById("secondPoolIpStart"+m) != '') && (document.getElementById("secondPoolIpEnd"+m) != '0.0.0.0' && document.getElementById("secondPoolIpEnd"+m) != '')) && (isInSubnet(stIpAddr, sec1stHdPoolIp, snetMask) || isInSubnet(endIpAddr, secEndHdPoolIp, snetMask)))
	                     {
	                     alert("Invalid Pool Configuration, Subnet already used for different Record's.");
	                     return false;
	                     }
	                 else if(((document.getElementById("thirdPoolIpStart"+m) != '0.0.0.0' && document.getElementById("thirdPoolIpStart"+m) != '') && (document.getElementById("thirdPoolIpEnd"+m) != '0.0.0.0' && document.getElementById("thirdPoolIpEnd"+m) != '')) && (isInSubnet(stIpAddr, third1stHdPoolIp, snetMask) || isInSubnet(endIpAddr, thirdEndHdPoolIp, snetMask)))
	                     {
	                     alert("Invalid Pool Configuration, Subnet already used for different Record's.");
	                     return false;
	                     }
	                 }
	             }
	         }
	     }
	     return true;
	 }
