/* pb.js - API library for Protocol Binding configuration */

/* Copyright 2011 TeamF1, Inc. */

/*
modification history 
------------------------
01a,18OCT11,mvb  written. 
*/

/* add_protocol_binding.htm */
function wanProtocolBindingsValidate ()
    {
    /* L10N Error Message Collection Start */
     var errMsgL10n1 ='Invalid destination network start IP address.';
     var errMsgL10n2 ='for octet';
     var errMsgL10n3 ='Invalid destination network end IP address.';
     var errMsgL10n4 ='Invalid source network start IP address.';
     var errMsgL10n5 ='Invalid source network end IP address.';
     var errMsgL10n6 ='Invalid IP Address range for Source Network';
     var errMsgL10n7 ='Invalid IP Address range for Destination Network';
     /* L10N Error Message Collection End */

     
	if (ipv4AddrOctetsValidate ('tblSrcNwStartAddr', 'IP', false, true,
             errMsgL10n4+"\n", errMsgL10n2+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('tblSrcNwEndAddr', 'IP', false, true,
             errMsgL10n5 + "\n", errMsgL10n2+" ", true) == false)
	    return false;
	if (ipRangeValidate ('tblSrcNwStartAddr','tblSrcNwEndAddr', errMsgL10n6) == false)
		return false;
	if (ipv4AddrOctetsValidate ('tblDstNwStartAddr', 'IP', false, true,
            errMsgL10n1+"\n", errMsgL10n2+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('tblDstNwEndAddr', 'IP', false, true,
             errMsgL10n3 + "\n", errMsgL10n2+" ", true) == false)
	    return false;
	if (ipRangeValidate ('tblDstNwStartAddr','tblDstNwEndAddr', errMsgL10n7) == false)
		return false;		
	if (checkDuplicateRules () == false)
        return false;
        
    return true;
    }
function protoBidingDstNwCheck ()
	{
	var selectedValue = comboSelectedValueGet ('selProtoBindDstNw');
	if (!selectedValue) return;
	switch (parseInt (selectedValue, 10))
		{
		case 1:
			fieldStateChangeWr ('','tblDstNwEndAddr','','tblDstNwStartAddr');
			break;
		case 2:
			fieldStateChangeWr ('','','','tblDstNwStartAddr tblDstNwEndAddr');
			break;
		default:
			fieldStateChangeWr ('','tblDstNwStartAddr tblDstNwEndAddr','','');
			break;
		}
	}
function protoBidingSrcNwCheck ()
	{
	var selectedValue = comboSelectedValueGet ('selProtoBindSrcNw');
	if (!selectedValue) return;
	switch (parseInt (selectedValue, 10))
		{
		case 1:
			fieldStateChangeWr ('','tblSrcNwEndAddr','','tblSrcNwStartAddr');
			break;
		case 2:
			fieldStateChangeWr ('','','','tblSrcNwStartAddr tblSrcNwEndAddr');
			break;
		default:
			fieldStateChangeWr ('','tblSrcNwStartAddr tblSrcNwEndAddr','','');
			break;
		}
	}
function wan1ProtocolBindingsInit ()
	{
	protoBidingDstNwCheck ();
	protoBidingSrcNwCheck ();
	}

function checkEnabledDuplicateRules ()
    {
    if (!pbRules || pbRules.length == 0) return true;
    var errorDisplayObj = document.getElementById ('tblErrMsg');
    // Collect all selected rowids to enable
    var tblObj = document.getElementById ('tblProtocolBinding');
    if (!tblObj) return true;
    var chkArray = tblObj.getElementsByTagName("INPUT");

    var rowids = new Array();
    var idx = 0;
    for (var i = 0; i < chkArray.length; i++)
         if (chkArray[i].type == 'checkbox' && chkArray[i].checked  && !chkArray[i].disabled && chkArray[i].value != '')
             {
             rowids[idx++] = chkArray[i].value;
             }

    // Enable all selected rules in array.
    for (idx = 0; idx < pbRules.length; idx++)
        {
        var rowid = pbRules[idx].rowId
        for (var i = 0; i < rowids.length; i++)
            {
            if (rowid == rowids[i])
                {
                if (pbRules[idx].enableStatus == "0")
                    {
                    pbRules[idx].oldStatus = "0";
                    pbRules[idx].enableStatus = "1";
                    }
                break;
                }
            }
        }
        
    // Now Check overlapped rules in enabled rules list
    for (var i = 0; i < pbRules.length; i++)
        {
        if (pbRules[i].enableStatus == "1")
            {
            var tempRule = pbRules[i];
            for (idx = 0; idx < pbRules.length; idx++)
                {
                if (pbRules[idx].rowId != tempRule.rowId && pbRules[idx].enableStatus == "1")
                    {
                    if (tempRule.serName == pbRules[idx].serName || tempRule.serName == "ANY" || pbRules[idx].serName == "ANY")
                        {
                        var errFlag = false;
                        var srcNwMatched = false;
                        var dstNwMatched = false;
                        var gwMatched = true;
                        
                        if (tempRule.locGw != pbRules[idx].locGw)
                            gwMatched = false;
            
                        if (tempRule.srcNwType == pbRules[idx].srcNwType &&
                            tempRule.srcSt == pbRules[idx].srcSt &&
                            tempRule.srcEnd == pbRules[idx].srcEnd &&
                            tempRule.dstNwType == pbRules[idx].dstNwType &&
                            tempRule.dstSt == pbRules[idx].dstSt &&
                            tempRule.dstEnd == pbRules[idx].dstEnd)
                            {
                            srcNwMatched = true;
                            dstNwMatched = true;
                            }
            
                        if (!srcNwMatched)
                            {
                            if (tempRule.srcNwType == "0" || pbRules[idx].srcNwType == "0" ||
                                (tempRule.srcNwType == "1" && pbRules[idx].srcNwType == "1" && tempRule.srcSt == pbRules[idx].srcSt))
                                {
                                srcNwMatched = true;
                                }
                            else if (tempRule.srcNwType == "1" && pbRules[idx].srcNwType == "2")
                                {
                                var srcStIPInt = convert_addr(tempRule.srcSt);
                                var srcStIPInt_old = convert_addr(pbRules[idx].srcSt);
                                var srcEndIPInt_old = convert_addr(pbRules[idx].srcEnd);
                                if (srcStIPInt >= srcStIPInt_old && srcStIPInt <= srcEndIPInt_old)
                                    {
                                    srcNwMatched = true;
                                    }
                                }
                            else if (tempRule.srcNwType == "2" && pbRules[idx].srcNwType == "1")
                                {
                                var srcStIPInt = convert_addr(tempRule.srcSt);
                                var srcEndIPInt = convert_addr(tempRule.srcEnd);
                                var srcStIPInt_old = convert_addr(pbRules[idx].srcSt);
                                if (srcStIPInt_old >= srcStIPInt && srcStIPInt_old <= srcEndIPInt)
                                    {
                                    srcNwMatched = true;
                                    }
                                }
                            else if (tempRule.srcNwType == "2" && pbRules[idx].srcNwType == "2")
                                {
                                var srcStIPInt = convert_addr(tempRule.srcSt);
                                var srcEndIPInt = convert_addr(tempRule.srcEnd);
                                var srcStIPInt_old = convert_addr(pbRules[idx].srcSt);
                                var srcEndIPInt_old = convert_addr(pbRules[idx].srcEnd);
                                if ((srcStIPInt >= srcStIPInt_old && srcStIPInt <= srcEndIPInt_old) ||
                                    (srcEndIPInt >= srcStIPInt_old && srcEndIPInt <= srcEndIPInt_old) ||
                                    (srcStIPInt_old >= srcStIPInt && srcStIPInt_old <= srcEndIPInt) ||
                                    (srcEndIPInt_old >= srcStIPInt && srcEndIPInt_old <= srcEndIPInt))
                                    {
                                    srcNwMatched = true;
                                    }
                                }
                            }
            
                        if (srcNwMatched && !dstNwMatched)
                            {
                            if (tempRule.dstNwType == "0" || pbRules[idx].dstNwType == "0" ||
                                (tempRule.dstNwType == "1" && pbRules[idx].dstNwType == "1" && tempRule.dstSt == pbRules[idx].dstSt))
                                {
                                dstNwMatched = true;
                                }
                            else if (tempRule.dstNwType == "1" && pbRules[idx].dstNwType == "2")
                                {
                                var dstStIPInt = convert_addr(tempRule.dstSt);
                                var dstStIPInt_old = convert_addr(pbRules[idx].dstSt);
                                var dstEndIPInt_old = convert_addr(pbRules[idx].dstEnd);
                                if (dstStIPInt >= dstStIPInt_old && dstStIPInt <= dstEndIPInt_old)
                                    {
                                    dstNwMatched = true;
                                    }
                                }
                            else if (tempRule.dstNwType == "2" && pbRules[idx].dstNwType == "1")
                                {
                                var dstStIPInt = convert_addr(tempRule.dstSt);
                                var dstEndIPInt = convert_addr(tempRule.dstEnd);
                                var dstStIPInt_old = convert_addr(pbRules[idx].dstSt);
                                if (dstStIPInt_old >= dstStIPInt && dstStIPInt_old <= dstEndIPInt)
                                    {
                                    dstNwMatched = true;
                                    }
                                }
                            else if (tempRule.dstNwType == "2" && pbRules[idx].dstNwType == "2")
                                {
                                var dstStIPInt = convert_addr(tempRule.dstSt);
                                var dstEndIPInt = convert_addr(tempRule.dstEnd);
                                var dstStIPInt_old = convert_addr(pbRules[idx].dstSt);
                                var dstEndIPInt_old = convert_addr(pbRules[idx].dstEnd);
                                if ((dstStIPInt >= dstStIPInt_old && dstStIPInt <= dstEndIPInt_old) ||
                                    (dstEndIPInt >= dstStIPInt_old && dstEndIPInt <= dstEndIPInt_old) ||
                                    (dstStIPInt_old >= dstStIPInt && dstStIPInt_old <= dstEndIPInt) ||
                                    (dstEndIPInt_old >= dstStIPInt && dstEndIPInt_old <= dstEndIPInt))
                                    {
                                    dstNwMatched = true;
                                    }
                                }
                            }

                        if (dstNwMatched && dstNwMatched && !gwMatched)
                            {
                            var errMsg = "Can not enable duplicate protocol binding rules";
                            if (errorDisplayObj) errorDisplayObj.innerHTML = errMsg;
                            else alert (errMsg);

                            // Reset all changed rules in array.
                            resetRulesState (rowids);

                            return false;
                            }
                        }
                    }
                }
            }
        }
    if (errorDisplayObj) errorDisplayObj.innerHTML = "";
    return true;
    }

function resetRulesState (rowids)
    {
    for (var idx = 0; idx < pbRules.length; idx++)
        {
        var rowid = pbRules[idx].rowId
        for (var i = 0; i < rowids.length; i++)
            {
            if (rowid == rowids[i])
                {
                if (pbRules[idx].enableStatus != pbRules[idx].oldStatus)
                    {
                    pbRules[idx].enableStatus = pbRules[idx].oldStatus;
                    }
                break;
                }
            }
        }
    }

function checkDuplicateRules ()
    {
    if (!pbRules || pbRules.length == 0) return true;

    var serObj = document.getElementById ('selSerName');
    var gwObj = document.getElementById ('selProtoBindGateway');
    var locGwObj = document.getElementById ('selProtoBindGateway');
    var srcNwTypeObj = document.getElementById ('selProtoBindSrcNw');
    var dstNwTypeObj = document.getElementById ('selProtoBindDstNw');
    var srcNwStIP = "";
    var srcNwEndIP = "";
    var dstNwStIP = "";
    var dstNwEndIP = "";
    
    if (srcNwTypeObj.value == "1")
        {
        srcNwStIP = getIPStr('tblSrcNwStartAddr');
        }
    else if (srcNwTypeObj.value == "2")
        {
        srcNwStIP = getIPStr('tblSrcNwStartAddr');
        srcNwEndIP = getIPStr('tblSrcNwEndAddr');
        }
        
    if (dstNwTypeObj.value == "1")
        {
        dstNwStIP = getIPStr('tblDstNwStartAddr');
        }
    else if (dstNwTypeObj.value == "2")
        {
        dstNwStIP = getIPStr('tblDstNwStartAddr');
        dstNwEndIP = getIPStr('tblDstNwEndAddr');
        }

    for (var idx = 0; idx < pbRules.length; idx++)
        {
        if (!serObj) break;
/*
        var configStr = serObj.value + " - " + pbRules[idx].serName + "\n" +
                        srcNwTypeObj.value + " - " + pbRules[idx].srcNwType + "\n" +
                        srcNwStIP + " - " + pbRules[idx].srcSt + "\n" +
                        srcNwEndIP + " - " + pbRules[idx].srcEnd + "\n" +
                        dstNwTypeObj.value + " - " + pbRules[idx].dstNwType + "\n" +
                        dstNwStIP + " - " + pbRules[idx].dstSt + "\n" +
                        dstNwEndIP + " - " + pbRules[idx].dstEnd;
        alert (configStr);
*/
        if (pbRules[idx].enableStatus == "1" &&
            (serObj.value == pbRules[idx].serName || serObj.value == "ANY" || pbRules[idx].serName == "ANY"))
            {
            var errFlag = false;
            var srcNwMatched = false;
            var dstNwMatched = false;
            var gwMatched = true;
            
            if (gwObj.value != pbRules[idx].locGw)
                gwMatched = false;

            if (srcNwTypeObj.value == pbRules[idx].srcNwType &&
                srcNwStIP == pbRules[idx].srcSt &&
                srcNwEndIP == pbRules[idx].srcEnd &&
                dstNwTypeObj.value == pbRules[idx].dstNwType &&
                dstNwStIP == pbRules[idx].dstSt &&
                dstNwEndIP == pbRules[idx].dstEnd)
                {
                srcNwMatched = true;
                dstNwMatched = true;
                }
            if (!srcNwMatched)
                {
                if (srcNwTypeObj.value == "0" || pbRules[idx].srcNwType == "0" ||
                    (srcNwTypeObj.value == "1" && pbRules[idx].srcNwType == "1" && srcNwStIP == pbRules[idx].srcSt))
                    {
                    srcNwMatched = true;
                    }
                else if (srcNwTypeObj.value == "1" && pbRules[idx].srcNwType == "2")
                    {
                    var srcStIPInt = convert_addr(srcNwStIP);
                    var srcStIPInt_old = convert_addr(pbRules[idx].srcSt);
                    var srcEndIPInt_old = convert_addr(pbRules[idx].srcEnd);
                    if (srcStIPInt >= srcStIPInt_old && srcStIPInt <= srcEndIPInt_old)
                        {
                        srcNwMatched = true;
                        }
                    }
                else if (srcNwTypeObj.value == "2" && pbRules[idx].srcNwType == "1")
                    {
                    var srcStIPInt = convert_addr(srcNwStIP);
                    var srcEndIPInt = convert_addr(srcNwEndIP);
                    var srcStIPInt_old = convert_addr(pbRules[idx].srcSt);
                    if (srcStIPInt_old >= srcStIPInt && srcStIPInt_old <= srcEndIPInt)
                        {
                        srcNwMatched = true;
                        }
                    }
                else if (srcNwTypeObj.value == "2" && pbRules[idx].srcNwType == "2")
                    {
                    var srcStIPInt = convert_addr(srcNwStIP);
                    var srcEndIPInt = convert_addr(srcNwEndIP);
                    var srcStIPInt_old = convert_addr(pbRules[idx].srcSt);
                    var srcEndIPInt_old = convert_addr(pbRules[idx].srcEnd);
                    if ((srcStIPInt >= srcStIPInt_old && srcStIPInt <= srcEndIPInt_old) ||
                        (srcEndIPInt >= srcStIPInt_old && srcEndIPInt <= srcEndIPInt_old) ||
                        (srcStIPInt_old >= srcStIPInt && srcStIPInt_old <= srcEndIPInt) ||
                        (srcEndIPInt_old >= srcStIPInt && srcEndIPInt_old <= srcEndIPInt))
                        {
                        srcNwMatched = true;
                        }
                    }
                }

            if (srcNwMatched && !dstNwMatched)
                {
                if (dstNwTypeObj.value == "0" || pbRules[idx].dstNwType == "0" ||
                    (dstNwTypeObj.value == "1" && pbRules[idx].dstNwType == "1" && dstNwStIP == pbRules[idx].dstSt))
                    {
                    dstNwMatched = true;
                    }
                else if (dstNwTypeObj.value == "1" && pbRules[idx].dstNwType == "2")
                    {
                    var dstStIPInt = convert_addr(dstNwStIP);
                    var dstStIPInt_old = convert_addr(pbRules[idx].dstSt);
                    var dstEndIPInt_old = convert_addr(pbRules[idx].dstEnd);
                    if (dstStIPInt >= dstStIPInt_old && dstStIPInt <= dstEndIPInt_old)
                        {
                        dstNwMatched = true;
                        }
                    }
                else if (dstNwTypeObj.value == "2" && pbRules[idx].dstNwType == "1")
                    {
                    var dstStIPInt = convert_addr(dstNwStIP);
                    var dstEndIPInt = convert_addr(dstNwEndIP);
                    var dstStIPInt_old = convert_addr(pbRules[idx].dstSt);
                    if (dstStIPInt_old >= dstStIPInt && dstStIPInt_old <= dstEndIPInt)
                        {
                        dstNwMatched = true;
                        }
                    }
                else if (dstNwTypeObj.value == "2" && pbRules[idx].dstNwType == "2")
                    {
                    var dstStIPInt = convert_addr(dstNwStIP);
                    var dstEndIPInt = convert_addr(dstNwEndIP);
                    var dstStIPInt_old = convert_addr(pbRules[idx].dstSt);
                    var dstEndIPInt_old = convert_addr(pbRules[idx].dstEnd);
                    if ((dstStIPInt >= dstStIPInt_old && dstStIPInt <= dstEndIPInt_old) ||
                        (dstEndIPInt >= dstStIPInt_old && dstEndIPInt <= dstEndIPInt_old) ||
                        (dstStIPInt_old >= dstStIPInt && dstStIPInt_old <= dstEndIPInt) ||
                        (dstEndIPInt_old >= dstStIPInt && dstEndIPInt_old <= dstEndIPInt))
                        {
                        dstNwMatched = true;
                        }
                    }
                }

            var errorDisplayObj = document.getElementById ('selSerNameErr');
            if (dstNwMatched && dstNwMatched && !gwMatched)
                {
                var errMsg = "Selected service with same source and destination network already exists on different Local Gateway.";
                if (errorDisplayObj) errorDisplayObj.innerHTML = errMsg;
                else alert (errMsg);
                return false;
                }
            else if (errorDisplayObj) errorDisplayObj.innerHTML = "";
            }
        }

    return true;
    }
