/* portTriggerring.js - API library for portTriggering configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01b,20MAY11,mvb  modified, modified port range check 1025-65535.
01a,5OCT10,mvb  written. 
*/

/* port_triggerring.htm and edit_port_triggering.htm */
function portTriggeringValidate ()
    {
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Enter a valid service name';   
    var errMsgL10n1a = 'Enter a valid outgoing start port value'; 
    var errMsgL10n1b = 'Enter a valid outgoing end port value';  
    var errMsgL10n1c = 'Enter a valid incoming start port value'; 
    var errMsgL10n1d = 'Enter a valid incoming end port value'; 
    var errMsgL10n2 = 'Invalid outgoing start port number - Please enter a value between 1-65535';    
    var errMsgL10n3 = 'Invalid outgoing start port number.';    
    var errMsgL10n4 = 'Invalid outgoing end port number - Please enter a value between 1-65535';    
    var errMsgL10n5 = 'Invalid outgoing end port number.';    
    var errMsgL10n6 = 'Invalid range of ports.'; 
    var errMsgL10n7 = 'End service port';    
    var errMsgL10n8 = 'should be greater than start service port';    
    var errMsgL10n9 = 'Invalid incoming start port number - Please enter a value between 1-65535';    
    var errMsgL10n10 = 'Invalid incoming start port number.';
     var errMsgL10n11 = 'Invalid incoming end port number - Please enter a value between 1-65535';    
    var errMsgL10n12 = 'Invalid incoming end port number.';
    /* L10N Error Message Collection End */  
        
    var txtFieldIdArr = new Array ();
    txtFieldIdArr[0] = "txtPortTriggerRuleName,"+ errMsgL10n1;
    txtFieldIdArr[1] = "txtPortTriggerOutRuleStartPort,"+ errMsgL10n1a;
    txtFieldIdArr[2] = "txtPortTriggerOutRuleEndPort,"+ errMsgL10n1b;
    txtFieldIdArr[3] = "txtPortTriggerInRuleStartPort,"+ errMsgL10n1c;
    txtFieldIdArr[4] = "txtPortTriggerInRuleEndPort,"+ errMsgL10n1d;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
	var obj = null;
    var startPort = 0;
	/* get and validate start port */
	obj = document.getElementById('txtPortTriggerOutRuleStartPort');
	if (portValueRangeCheck (obj, 1025, 65535, 1024, null, true, "Invalid outgoing start port number.", "") == false)
         return false;
    startPort = obj.value;
	/* get and validate end port */
	obj = document.getElementById('txtPortTriggerOutRuleEndPort');
	if (portValueRangeCheck (obj, 1025, 65535, 1024, null, true, "Invalid outgoing end port number.", "") == false)
         return false;
	if (parseInt (obj.value, 10) < parseInt (startPort, 10))
       {
        alert (errMsgL10n6+ errMsgL10n7+" (" + obj.value +
               ")"+errMsgL10n8+" (" +startPort + ")");
        return false;
        }
    var startPort = 0;
	/* get and validate start port */
	obj = document.getElementById('txtPortTriggerInRuleStartPort');
	if (portValueRangeCheck (obj, 1025, 65535, 1024, null, true, "Invalid incoming start port number.", "") == false)
         return false;
    startPort = obj.value;
	/* get and validate end port */
 	obj = document.getElementById('txtPortTriggerInRuleEndPort');	
	if (portValueRangeCheck (obj, 1025, 65535, 1024, null, true, "Invalid incoming end port number.", "") == false)
         return false;
	if (parseInt (obj.value, 10) < parseInt (startPort, 10))
        {
        alert (errMsgL10n6+ errMsgL10n7 +" (" + obj.value +
               ")"+ errMsgL10n8 +" (" +startPort + ")");
        return false;
        }
    if(maxCountCheck ('hdCount', 16, 'tblErrMsg') == false)
		return false;   
    return true;    
    }
