/* qosNetwork.js - API library for Network QoS Configuration */

/* Copyright 2010 TeamF1, Inc. */

function qosHostCheck ()
   {
	var selHostValue = comboSelectedValueGet  ('selHosts');
	if (!selHostValue) return;
	switch (parseInt (selHostValue, 10))
		{
		case 3: /* Group */
			fieldStateChangeWr ('','tblStartIPAddr tblEndIPAddr','qosSelGroup selBandAllocation','');
			break;
		case 1:	/* Single IP Address */
            fieldStateChangeWr ('qosSelGroup selBandAllocation','tblEndIPAddr','','tblStartIPAddr');
            break;
		default: /* IP Address range */
			fieldStateChangeWr ('qosSelGroup','','selBandAllocation','tblStartIPAddr tblEndIPAddr');
			break;
		}
   }

function qosBwCheck ()
    {
    var selQosTypeVal = comboSelectedValueGet('selQosType');
    if (!selQosTypeVal) return;

    if (parseInt (selQosTypeVal, 10) == 0)
        {
	    var selDirValue = comboSelectedValueGet  ('selDirection1');
        if (!selDirValue) return;
        
        switch (parseInt (selDirValue, 10))
            {
            case 2: /* Outbound */
                fieldStateChangeWr ('txtMinBandwidthIb txtMaxBandwidthIb','','txtMinBandwidthOb txtMaxBandwidthOb','');
                break;
            case 1: /* Inbound */
                fieldStateChangeWr ('txtMinBandwidthOb txtMaxBandwidthOb','','txtMinBandwidthIb txtMaxBandwidthIb','');
                break;
            case 3: /* Both */
                fieldStateChangeWr ('','','txtMinBandwidthOb txtMaxBandwidthOb txtMinBandwidthIb txtMaxBandwidthIb','');
                break;
            default: /* Error case */
                fieldStateChangeWr ('txtMinBandwidthIb txtMaxBandwidthIb','','txtMinBandwidthOb txtMaxBandwidthOb','');
                break;
            }
        }
    }
	
function qosTypeCheck ()
    {
    var selQosTypeVal = comboSelectedValueGet ('selQosType');
    var selTDText = document.getElementById('txtChangeTd');
    var viewPrioObj = document.getElementById('viewPrio');
    var hidePrioObj = document.getElementById('hidePrio');
    var viewDirObj = document.getElementById('viewDir');
    var hideDirObj = document.getElementById('hideDir');
	if (!selQosTypeVal) return;
	switch (parseInt (selQosTypeVal, 10))
		{
		case 1: /* Priority */
            fieldStateChangeWr ('selHosts qosSelGroup selBandAllocation txtMinBandwidthOb txtMaxBandwidthOb txtMinBandwidthIb txtMaxBandwidthIb','tblStartIPAddr tblEndIPAddr','','');
            selTDText.innerHTML = document.getElementById('hdPrioLang').value;
            viewDirObj.className = "hide";
            hideDirObj.className = "show";
            viewPrioObj.className = "hide";
            hidePrioObj.className = "show";
			break;
		case 0:	/* Rate Control */
		default:
			fieldStateChangeWr ('','','selHosts qosSelGroup selBandAllocation txtMinBandwidthOb txtMaxBandwidthOb txtMinBandwidthIb txtMaxBandwidthIb','tblStartIPAddr tblEndIPAddr');
            selTDText.innerHTML = document.getElementById('hdCongPrioLang').value;
            viewDirObj.className = "show";
            hideDirObj.className = "hide";
            viewPrioObj.className = "show";
            hidePrioObj.className = "hide";
			qosHostCheck ();
			break;
        }
    qosBwCheck ();
    }
	
function netQoSProfile_addValidate ()
    {
    
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtMinBandwidthOb, Please Enter Outbound Minimum Bandwidth";
    txtFieldIdArr[1] = "txtMaxBandwidthOb, Please Enter Outbound Maximum Bandwidth";
    txtFieldIdArr[2] = "txtMinBandwidthIb, Please Enter Inbound Minimum Bandwidth";
    txtFieldIdArr[3] = "txtMaxBandwidthIb, Please Enter Inbound Maximum Bandwidth";

    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;

	if (ipv4AddrOctetsValidate ('tblStartIPAddr', 'IP', false, true,
             'Invalid starting IP address', 'for octet ', true) == false)
		return false;
	if (ipv4AddrOctetsValidate ('tblEndIPAddr', 'IP', false, true,
             'Invalid ending IP address', 'for octet ', true) == false)
		return false;
	if (ipRangeValidate ('tblStartIPAddr','tblEndIPAddr', 'Hosts') == false)
		return false;
		
	obj = document.getElementById('txtMinBandwidthOb');
    if (obj && !obj.disabled)
        {
        if (numericValueRangeCheck (obj, '', '', 0, 100000, true, 'Invalid Minimum Outbound Bandwidth'+':', '') == false)
            return false;
        }

    obj = document.getElementById('txtMinBandwidthIb');
    if (obj && !obj.disabled)
        {
        if (numericValueRangeCheck (obj, '', '', 0, 100000, true, 'Invalid Minimum Inbound Bandwidth'+':', '') == false)
            return false;
        }

	obj2 = document.getElementById('txtMaxBandwidthOb');
    if (obj2 && !obj2.disabled)
        {
        if (numericValueRangeCheck (obj2, '', '', 100, 100000, true, 'Invalid Maximum Outbound Bandwidth'+':', '') == false)
            return false;
        }

    obj2 = document.getElementById('txtMaxBandwidthIb');
    if (obj2 && !obj2.disabled)
        {
        if (numericValueRangeCheck (obj2, '', '', 100, 100000, true, 'Invalid Maximum Inbound Bandwidth'+':', '') == false)
            return false;
        }

    obj3 = document.getElementById('txtQoSDiffSrvr');
    if (obj3 && obj3.value != '')
        {
        if (numericValueRangeCheck (obj3, '', '', 0, 63, true, 'Invalid DSCP match value'+':', '') == false)
            return false;
        }

    obj4 = document.getElementById('txtDiffSrvrRmrk');
    if (obj4 && obj4.value != '')
        {
        if (numericValueRangeCheck (obj4, '', '', 0, 63, true, 'Invalid DSCP remark value'+':', '') == false)
            return false;
        }
	
	return true;
   }
