/* remoteMgmt.js - API library for Remote Management configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,19OCT10,mvb  written. 
*/

/* remote_mgmt.htm */
function remoteMgmtValidation ()
    {
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid starting IP address range for HTTP.';    
    var errMsgL10n2 = 'for octet';
    var errMsgL10n3 = 'Invalid ending IP address range for HTTP.';    
    var errMsgL10n4 = 'HTTP Management';    
    var errMsgL10n5 = 'Invalid IP address of HTTP management PC.';    
    var errMsgL10n6 = 'Invalid port number - Please enter a value between 0-65535';    
    var errMsgL10n7 = 'Invalid port number';    
    var errMsgL10n8 = 'Invalid starting IP address range for Telnet.';    
    var errMsgL10n9 = 'Invalid ending IP address range for Telnet.';
    var errMsgL10n10 = 'Telnet Management';
    var errMsgL10n11 = 'Invalid IP address of Telnet management PC.';
    
     /* L10N Error Message Collection End */    
    
    if (ipv4AddrOctetsValidate ('tblRemoteFromAddr', 'IP', false, true,
            errMsgL10n1, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('tblRemoteToAddr', 'IP', false, true,
             errMsgL10n3, errMsgL10n2+" ", true) == false)
	    return false;
	    
    if (ipRangeValidate ('tblRemoteFromAddr','tblRemoteToAddr', errMsgL10n4) == false)
		return false;
				
	if (ipv4AddrOctetsValidate ('tblOnlyThisPC', 'IP', false, true,
             errMsgL10n5, errMsgL10n2+" ", true) == false)
    	return false;
	/* get and validate port number */
	obj = document.getElementById('txtRemoteMgmtPortNum');
	if (portValueRangeCheck (obj, 1025, 65535, '', 443, true, 'Invalid port number:') == false)
		return false;
	if (ipv4AddrOctetsValidate ('tblTelnetFromAddr', 'IP', false, true,
             errMsgL10n8, errMsgL10n2+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('tblTelnetToAddr', 'IP', false, true,
             errMsgL10n9, errMsgL10n2+" ", true) == false)
	    return false;

    if (ipRangeValidate ('tblTelnetFromAddr','tblTelnetToAddr', errMsgL10n10) == false)
		return false;

	if (ipv4AddrOctetsValidate ('tblOnlyThisPCTelnet', 'IP', false, true,
             errMsgL10n11,errMsgL10n2+" ", true) == false)
    	return false;

	return true;
    }
    
function remoteMgmtValidationIpv6 ()
    {
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid starting IP address range for HTTP.';    
    var errMsgL10n2 = 'for octet';
    var errMsgL10n3 = 'Invalid ending IP address range for HTTP.';    
    var errMsgL10n4 = 'HTTP Management';    
    var errMsgL10n5 = 'Invalid IP address of HTTP management PC.';    
    var errMsgL10n6 = 'Invalid port number - Please enter a value between 0-65535';    
    var errMsgL10n7 = 'Invalid port number';    
    var errMsgL10n8 = 'Invalid starting IP address range for Telnet.';    
    var errMsgL10n9 = 'Invalid ending IP address range for Telnet.';
    var errMsgL10n10 = 'Telnet Management';
    var errMsgL10n11 = 'Invalid IP address of Telnet management PC.';
    
     /* L10N Error Message Collection End */    
    
	/*HTTP ipv6 start */    
    if (ipv6Validate ('txtRmtV6FromAddr', false, true, '') == false)
	    return false;
	
	if (ipv6Validate ('txtRmtV6ToAddr', false, true, '') == false)
	    return false;
	
	if (startEndCompare('txtRmtV6FromAddr','txtRmtV6ToAddr') == false)
		return false;
	
	if (ipv6Validate ('txtRmtV6OnlyPC', false, true, '') == false)
	    return false;    
    /*HTTP ipv6 end */
    	/* get and validate port number */
	obj = document.getElementById('txtRemoteMgmtPortNum');
	if (portValueRangeCheck (obj, 1025, 65535, '', 443, true, 'Invalid port number:') == false)
		return false;
    	
    /*TelNet ipv6 start */    
    if (ipv6Validate ('txtTelNetV6FromAddr', false, true, '') == false)
	    return false;
	
	if (ipv6Validate ('txtTelNetV6ToAddr', false, true, '') == false)
	    return false;
	
	if (startEndCompare('txtTelNetV6FromAddr','txtTelNetV6ToAddr') == false)
		return false;
	
	if (ipv6Validate ('txtTelNetV6OnlyPC', false, true, '') == false)
	    return false;    
    /*Telnet ipv6 end */

	return true;
    }

function remoteMgmtConfCheck ()
	{
	var selValue = radioCheckedValueGet ('accessMgmt.accessMgmtEnable');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* NO */
			fieldStateChangeWr ('','tblRemoteMgmtSettings','','');
			break;
		case 1:	/* YES */
			fieldStateChangeWr ('','','','tblRemoteMgmtSettings');
			remoteMgmtAccessTypeCheck ();
			/* set the https connect URL informarion */
			var httpsAddr = document.getElementById ('hd.wanHttpsIP').value;
			if (!httpsAddr.length)
			{
			var httpsAddr_wan1 = document.getElementById ('hd.wan1HttpsIP').value;
			var httpsAddr_wan2 = document.getElementById ('hd.wan2HttpsIP').value;
			var httpsAddr_wan3 = document.getElementById ('hd.wan3HttpsIP').value;
			var httpsAddr_wan4 = document.getElementById ('hd.wan4HttpsIP').value;
			if (!httpsAddr_wan1.length || !httpsAddr_wan2.length || !httpsAddr_wan3.length || !httpsAddr_wan4.length)
				break;
			var httpsPort = document.getElementById ('hd.wanHttpsPort').value;
			var httpsMsg = 'IP Address to connect to this device: <br>' +

						   '<a style="color: #40087F; text-decoration: underline" href="https:\/\/' + httpsAddr_wan1 + ":" + httpsPort +
						   '">https:\/\/' + httpsAddr_wan1 + ":" + httpsPort + '</a>' + ' (or) <br>' +
				         	   '<a style="color: #40087F; text-decoration: underline" href="https:\/\/' + httpsAddr_wan2 + ":" + httpsPort +
						   '">https:\/\/' + httpsAddr_wan2 + ":" + httpsPort + '</a>' +	' (or) <br>' +
				         	   '<a style="color: #40087F; text-decoration: underline" href="https:\/\/' + httpsAddr_wan3 + ":" + httpsPort +
						   '">https:\/\/' + httpsAddr_wan3 + ":" + httpsPort + '</a>' + ' (or) <br>' +
						   '<a style="color: #40087F; text-decoration: underline" href="https:\/\/' + httpsAddr_wan4 + ":" + httpsPort +
						   '">https:\/\/' + httpsAddr_wan4 + ":" + httpsPort + '</a>' +
					   '<span class="lbl4"><br> (Be sure to type &quot;https&quot; not &quot;http&quot;)</span>';
			lblConnInfo.innerHTML = httpsMsg;
			break;
			}
			else
			{
			var httpsPort = document.getElementById ('hd.wanHttpsPort').value;
			var httpsMsg = 'IP Address to connect to this device: ' +

						   '<a style="color: #40087F; text-decoration: underline" href="https:\/\/' + httpsAddr + ":" + httpsPort +
						   '">https:\/\/' + httpsAddr + ":" + httpsPort + '</a>' +
						   '<span class="lbl4"><br> (Be sure to type &quot;https&quot; not &quot;http&quot;)</span>';
			lblConnInfo.innerHTML = httpsMsg;
			break;
         		}
	        }
	}
function remoteMgmtAccessTypeCheck ()
	{
	var selValue = radioCheckedValueGet ('accessMgmt.accessType');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* Every One */
			fieldStateChangeWr ('','tblRemoteFromAddr tblRemoteToAddr tblOnlyThisPC','','');
			break;
		case 1:	/* IP address range */
			fieldStateChangeWr ('','tblOnlyThisPC','','tblRemoteToAddr tblRemoteFromAddr');
			break;
		case 2:	/* Only this PC */
			fieldStateChangeWr ('','tblRemoteToAddr tblRemoteFromAddr','','tblOnlyThisPC');
			break;
		}
	}
function remoteTelnetConfCheck ()
	{
	var selValue = radioCheckedValueGet ('telnet.telnetEnable');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* NO */
			fieldStateChangeWr ('','tblTelnetMgmt','','');
			break;
		case 1:	/* YES */
			fieldStateChangeWr ('','','','tblTelnetMgmt');
			remoteMgmtAccessTypeCheckTelnet ();
		}
	}
function remoteMgmtAccessTypeCheckTelnet ()
	{
	var selValue = radioCheckedValueGet ('telnet.telnetAccessType');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* Every One */
			fieldStateChangeWr ('','tblTelnetFromAddr tblTelnetToAddr tblOnlyThisPCTelnet','','');
			break;
		case 1:	/* IP address range */
			fieldStateChangeWr ('','tblOnlyThisPCTelnet','','tblTelnetToAddr tblTelnetFromAddr');
			break;
		case 2:	/* Only this PC */
			fieldStateChangeWr ('','tblTelnetToAddr tblTelnetFromAddr','','tblOnlyThisPCTelnet');
			break;
		}
	}
    
function remoteMgmtInit ()
	{
	remoteMgmtConfCheck ();
	remoteTelnetConfCheck ();
	remoteMgmtAccessTypeCheck ();
	remoteMgmtAccessTypeCheckTelnet ();
	}

function remoteMgmtInit1 ()
	{
	remoteMgmtConfCheck ();
	remoteTelnetConfCheck ();
	ipModeType ();
	}

function ipModeType ()
    {
    var ipModeObj = document.getElementById('ipModeType');
    if(ipModeObj)
        var ipModeObjVal = ipModeObj.value;
    if(ipModeObjVal != '' && ipModeObjVal == 3)
        {
        fieldStateChangeWr ('','','','tdHTTPipv6 tdTelNetipv6');
        remoteMgmtEnableV6Check ();
        telNetMgmtEnableV6Check ()
        }
    else
        {
        fieldStateChangeWr ('','tdHTTPipv6 tdTelNetipv6','','');
        }
        
    }   
function remoteMgmtEnableV6Check ()
    {
    var remoteMgmtV6SelVal = radioCheckedValueGet ('accessMgmt.accessMgmt6Enable');
    if(parseInt(remoteMgmtV6SelVal, 10) == 1) /*YES*/
        {
        fieldStateChangeWr ('','','','tblRemoteMgmtIPv6');
        portNumEnableCheck ();
        remoteMgmtAccessTypeV6Check ();
        }
    else
        {
        fieldStateChangeWr ('','tblRemoteMgmtIPv6','','');
        portNumEnableCheck ();
        }    
    }

function telNetMgmtEnableV6Check ()
    {
    var telNetMgmtV6SelVal = radioCheckedValueGet ('telnet.telnetV6Enable');
    if(parseInt(telNetMgmtV6SelVal, 10) == 1) /*YES*/
        {
        fieldStateChangeWr ('','','','tblTelNetMgmtIPv6');
        telNetAccessTypeV6Check ();
        }
    else
        {
        fieldStateChangeWr ('','tblTelNetMgmtIPv6','','');
        }    
    }
  
function portNumEnableCheck ()
    {
    var ipModeVal = document.getElementById('ipModeType').value;
    var selValue = radioCheckedValueGet ('accessMgmt.accessMgmtEnable');
    if(parseInt(ipModeVal, 10) == 3)
        {
        var sel6Value = radioCheckedValueGet ('accessMgmt.accessMgmt6Enable');
        if(parseInt(selValue, 10) == 0 && parseInt(sel6Value, 10) == 0)
            fieldStateChangeWr ('txtRemoteMgmtPortNum','','','');
        else
            fieldStateChangeWr ('','','txtRemoteMgmtPortNum','');
        }
    }

  function remoteMgmtAccessTypeV6Check ()
	{
	var selValue = radioCheckedValueGet ('accessMgmt.accessType6');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* Every One */
			fieldStateChangeWr ('txtRmtV6FromAddr txtRmtV6ToAddr txtRmtV6OnlyPC','','','');
			break;
		case 1:	/* IP address range */
			fieldStateChangeWr ('txtRmtV6OnlyPC','','txtRmtV6FromAddr txtRmtV6ToAddr','');
			break;
		case 2:	/* Only this PC */
			fieldStateChangeWr ('txtRmtV6FromAddr txtRmtV6ToAddr','','txtRmtV6OnlyPC','');
			break;
		}
	}

  function telNetAccessTypeV6Check ()
	{
	var selValue = radioCheckedValueGet ('telnet.telnetV6AccessType');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 0:	/* Every One */
			fieldStateChangeWr ('txtTelNetV6FromAddr txtTelNetV6ToAddr txtTelNetV6OnlyPC','','','');
			break;
		case 1:	/* IP address range */
			fieldStateChangeWr ('txtTelNetV6OnlyPC','','txtTelNetV6FromAddr txtTelNetV6ToAddr','');
			break;
		case 2:	/* Only this PC */
			fieldStateChangeWr ('txtTelNetV6FromAddr txtTelNetV6ToAddr','','txtTelNetV6OnlyPC','');
			break;
		}
	}
