/* sslvpnClient.js - API library for sslvpnClient configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01b,26APRIL11,mvb  modified. add maxlimit count check in VPNTunnelclientIPValidate();
01a,11OCT10,mvb  written. 
*/

function clientIPValidate ()
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid Primary DNS IP address.';
    var errMsgL10n2 = 'for octet';
    var errMsgL10n3 = 'Invalid Secondary DNS IP address.';
    var errMsgL10n4 = 'Invalid Client Address Range Begin.';
    var errMsgL10n5 = 'Invalid Client Address Range End.';
    var errMsgL10n6 = 'DNS Suffix';     
    
    if(document.getElementById ('txtDnsSuffix').value != "")
        {
        if(validateFQDN('txtDnsSuffix') == false) 
           return false; 	
        }

	if(document.getElementById('tblPriDnsServer').value != '' || document.getElementById('tblSecDnsServer').value != '')
	    {
	    if(ipVersionCheck ('tblPriDnsServer', 'tblSecDnsServer') == false)
		    return false;
		}
	
	if (ipv4Validate('tblSnmpStrIpAddr', 'IP', false, true, 'Invalid Client Address Range Begin', 'for octet ', true) == false)
	    return false;
	if (ipv4Validate('tblSnmpEndIpAddr', 'IP', false, true, 'Invalid Client Address Range End', 'for octet ', true) == false)
	    return false;
		
	return true;	
    }

function fullTunnelCheck ()
	{
	var obj = document.getElementById('chkEnbFullTnl');
	if(obj.checked)
	    fieldStateChangeWr ('','tblClientRoutes tblAddRoute','','');
	else
	   fieldStateChangeWr ('','','','tblClientRoutes tblAddRoute');
	   
	}

function getFlagVal()
    {
    var hdIPModeObj = document.getElementById('ipModeType');
    var hdIPModeVal = '';
    var flag = 0;
    if(hdIPModeObj) hdIPModeVal = hdIPModeObj.value;
    if(hdIPModeVal != '' && hdIPModeVal == 3)
        {
        flag = 1; //IPv6Addr
        }
    else
        {
        flag = 2; /*ipv4 validation */
        }        
    return flag;    
    }

function VPNTunnelclientIPValidate ()
	{	
        
    if (ipv4AddrOctetsValidate ('tblSnmpIpAddr', 'SN', false, true, 'Invalid IP address', 'for octet', true) == false)
        return false;
        
	var objArr = getIPStr('tblSnmpIpAddr');
	if (parseInt (objArr[3].value, 10) == 0)
	    {
	    if (ipv4AddrOctetsValidate ('tblWi1IpSnetmask', 'SM', false, true, 'Invalid subnet mask', 'for octet', true) == false)
	       return false;
        }
    else
        {
        if (ipv4AddrOctetsValidate ('tblWi1IpSnetmask', 'SNM', false, true, 'Invalid subnet mask', 'for octet', true) == false)
            return false;
        }
    
    if(subnetValidate('tblSnmpIpAddr', 'tblWi1IpSnetmask',' for Destination Network')==false)
        return false;
    
    if(maxCountCheck ('hdCount', 32, 'tblErrMsg') == false)
	    return false;        
        
    return true;
	}  


function ipVersionCheck (ipAddr, ipAddr2)
    {
    var flagg = getFlagVal();
    if(flagg == 1)
        {
        var tblIpAddrObj = document.getElementById (ipAddr);
        var whichIpAddr = isIpv4OrIpv6 (tblIpAddrObj);
        if(whichIpAddr == "IPV4")
            {
            if (ipv4Validate (ipAddr, 'IP', false, true, "Invalid IP Address.", "for octet ", true) == false)
                return false;
            if(document.getElementById('tblSecDnsServer').value != '')
                {
                if (ipv4Validate (ipAddr2, 'IP', false, true, "Invalid IP Address.", "for octet ", true) == false)
                    return false;
                }
            }
        else if(whichIpAddr == "IPV6")
            {
            if (ipv6Validate (ipAddr, true, true, '') == false)
                return false;
            if(document.getElementById('tblSecDnsServer').value != '')
                {
                if (ipv6Validate (ipAddr2, true, true, '') == false)
                    return false;
                }
            }
        else
            {
            alert('Please enter valid IPv4 or IPv6 address');
            tblIpAddrObj.focus();
            return false;
            }
        }
    else
        {
        if (ipv4Validate (ipAddr, 'IP', false, true, "Invalid IP Address.", "for octet ", true) == false)
            return false;
        if(document.getElementById('tblSecDnsServer').value != '')
            {
            if (ipv4Validate (ipAddr2, 'IP', false, true, "Invalid IP Address.", "for octet ", true) == false)
                return false;
            }
        }
    return true;
    }

